--- webserver_old.c	2021-10-14 19:11:37.000000000 +0200
+++ webserver.c	2021-10-15 10:55:57.000000000 +0200
@@ -85,8 +85,12 @@
 		hdrptr += strlen(searchstr); 
 		if (hdrend = strstr(hdrptr, "\r\n")) { 
 			char hdrval[1024]; // temporary return value
-			memcpy((char *)hdrval, hdrptr, (hdrend - hdrptr));
-			hdrval[hdrend - hdrptr] = '\0'; // tack null onto end of header value
+			int hdrlen = hdrend - hdrptr; //header length
+			if(hdrlen > 1024){
+				return 0;
+			}
+			memcpy((char *)hdrval, hdrptr, hdrlen);
+			hdrval[hdrlen] = '\0'; // tack null onto end of header value
 			int hdrvallen = strlen(hdrval);
 			retval = (char *)malloc((hdrvallen + 1) * sizeof(char)); // malloc a space for retval
 			strcpy(retval, (char *)hdrval);
@@ -212,7 +216,7 @@
 
 int send_response(int sockfd, httpreq_t *req, int statcode) {
 	int urifd;
-	const int BUFSIZE = 1024;
+	const int BUFSIZE = 4608;
 	char sendmessage[BUFSIZE];
 	char *path = req->uri;
 
@@ -221,7 +225,6 @@
 		return 0;
 	}
 
-
 	if ((path[0] == '/') || ((strstr(path, "http://") == path)
 							 && (path = strchr(path + 7,  '/')))) {
 		path += 1; // remove leading slash
@@ -235,6 +238,10 @@
 		statcode = 400;
 	}
 
+	if(strlen(path)>4096){
+		statcode = 400;
+	}
+
 	if (statcode == 200 && (urifd = open(path, O_RDONLY, 0)) < 0) {
 		if (errno == ENOENT || errno == ENOTDIR) { // file or directory doesn't exist
 			statcode = 404;
@@ -310,8 +317,11 @@
 		strcat(sendmessage, "</title></head><body><h2>HTTP/1.0</h2><h1>");
 		strcat(sendmessage, status(statcode));
 		strcat(sendmessage, "</h1><h2>URI: ");
-		strcat(sendmessage, path);
+		strncat(sendmessage, path, 4096);
 		strcat(sendmessage, "</h2></body></html>");
+		//good way to do string concatenation
+		//only if we want to send back the error 
+		//snprintf(sendmessage, BUFSIZE-strlen(sendmessage)-1, "<html><head><title>%s</title></head><body><h2>HTTP/1.0</h2><h1>%s</h1><h2>URI: %s</h2></body></html>", status(statcode), status(statcode), path);
 	}
 
 	if (sendmessage[0] != '\0') {
@@ -439,7 +449,7 @@
 
 	// used to deref a NULL pointer here... :(
 	if (headerstr != NULL) {
-		printf("%s\n", headerstr);
+		//printf("%s\n", headerstr);
 		free(headerstr);
 	}
 
